/*
 * Unique Schlüssel für JPA Entität
 */
package de.ivu.elect.business.niederschrift.entity;
import java.util.function.Function;
import java.util.ArrayList;
import java.util.stream.Collectors;

@javax.enterprise.inject.Vetoed
public class NiederschriftUK
implements de.ivu.elect.jee.entity.tk.EntityUK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

    protected final de.ivu.elect.business.niederschrift.entity.NiederschriftArt niederschriftArt;

    public de.ivu.elect.business.niederschrift.entity.NiederschriftArt getNiederschriftArt(){
      return niederschriftArt;
    }

  protected final de.ivu.elect.business.gebietsbaum.entity.WahldurchfuehrungsgebietUK wahldurchfuehrungsgebietUK;

    public de.ivu.elect.business.gebietsbaum.entity.WahldurchfuehrungsgebietUK getWahldurchfuehrungsgebietUK(){
      return wahldurchfuehrungsgebietUK;
    }

  public NiederschriftUK(
de.ivu.elect.business.niederschrift.entity.NiederschriftArt niederschriftArt
,   de.ivu.elect.business.gebietsbaum.entity.WahldurchfuehrungsgebietUK wahldurchfuehrungsgebietUK
  ) {
    super();


      this.niederschriftArt = niederschriftArt;
        this.wahldurchfuehrungsgebietUK = wahldurchfuehrungsgebietUK;
    }

  @Override
  public int hashCode() {
        int result = 1;
    
    
                    result = result + ((niederschriftArt == null) ? 0 : niederschriftArt.hashCode());
        
                    result = result + ((wahldurchfuehrungsgebietUK == null) ? 0 : wahldurchfuehrungsgebietUK.hashCode());
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    
    if (getClass() != obj.getClass()) {
      return false;
    }

            NiederschriftUK other = (NiederschriftUK) obj;

                if (niederschriftArt == null) {
          if (other.niederschriftArt != null) {
            return false;
          }
        } else if (!niederschriftArt.equals(other.niederschriftArt)) {
          return false;
        }
        
                if (wahldurchfuehrungsgebietUK == null) {
          if (other.wahldurchfuehrungsgebietUK != null) {
            return false;
          }
        } else if (!wahldurchfuehrungsgebietUK.equals(other.wahldurchfuehrungsgebietUK)) {
          return false;
        }
            
    return true;
  }

  @Override
  public String getEntityMessageKey() {
    return NiederschriftConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    result.addAll(wahldurchfuehrungsgebietUK.getAllEntityFieldValues());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(NiederschriftConstants.MESSAGE_KEY_ENTITY_EINZAHL, NiederschriftConstants.MESSAGE_KEY_NIEDERSCHRIFT_ART_EINZAHL, niederschriftArt));
        
        return result;
      }
  
    @Override
  public String toString() {
    return "NiederschriftUK[" + toStringParameter() + "]";
  }

            protected String toStringParameter() {
              String result = ""

                                                        +"niederschriftArt="+niederschriftArt
                                        +", "                +"wahldurchfuehrungsgebietUK="+wahldurchfuehrungsgebietUK
                        ;
                          return result;
            
            }




          public String allUKFields() {
    return String.join(", ", getAllUKFieldValues().stream()
         .map(object -> (object != null ? object.toString() : null))
         .collect(Collectors.toList()));
    }

   protected ArrayList<Object> getAllUKFieldValues() {
              ArrayList<Object> list = new ArrayList<>();
              list.add(niederschriftArt);
     return list;
   }

            public static <E extends Niederschrift> java.util.Map<NiederschriftUK, E> mappeNiederschriftNachUK(java.util.Collection<E> entities) {

                return entities.stream().collect(java.util.stream.Collectors.toMap(Niederschrift::getNiederschriftUK, Function.<E>identity(), (u,v)->v));
             }


                public static Function<Niederschrift, NiederschriftUK> getNiederschriftToUKFunction() {
                return Niederschrift::getNiederschriftUK;
                }

}
